Index: /branches/UKMO/dev_r5518_medusa_chg_trc_bio_medusa/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90
===================================================================
--- /branches/UKMO/dev_r5518_medusa_chg_trc_bio_medusa/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 7885)
+++ /branches/UKMO/dev_r5518_medusa_chg_trc_bio_medusa/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 7886)
@@ -4089,82 +4063,82 @@
                   !  ENDIF
                   IF( med_diag%DETN%dgsave ) THEN
-                      fslown2d(ji,jj) = fslown2d(ji,jj) + (fslown  * fthk)  
+                      fslown2d(ji,jj) = fslown2d(ji,jj) + (fslown(ji,jj)  * fse3t(ji,jj,jk))  
                   ENDIF
                   IF( med_diag%MDET%dgsave ) THEN
-                      fdd2d(ji,jj) = fdd2d(ji,jj) + (fdd     * fthk) 
+                      fdd2d(ji,jj) = fdd2d(ji,jj) + (fdd(ji,jj)     * fse3t(ji,jj,jk)) 
                   ENDIF
                   IF( med_diag%AEOLIAN%dgsave ) THEN
-                      ffetop2d(ji,jj) = ffetop2d(ji,jj) + (ffetop  * fthk) 
+                      ffetop2d(ji,jj) = ffetop2d(ji,jj) + (ffetop(ji,jj)  * fse3t(ji,jj,jk)) 
                   ENDIF
                   IF( med_diag%BENTHIC%dgsave ) THEN
-                      ffebot2d(ji,jj) = ffebot2d(ji,jj) + (ffebot  * fthk) 
+                      ffebot2d(ji,jj) = ffebot2d(ji,jj) + (ffebot(ji,jj)  * fse3t(ji,jj,jk)) 
                   ENDIF
                   IF( med_diag%SCAVENGE%dgsave ) THEN
-                      ffescav2d(ji,jj) = ffescav2d(ji,jj) + (ffescav * fthk)  
+                      ffescav2d(ji,jj) = ffescav2d(ji,jj) + (ffescav(ji,jj) * fse3t(ji,jj,jk))  
                   ENDIF
                   IF( med_diag%PN_JLIM%dgsave ) THEN
-                      ! fjln2d(ji,jj) = fjln2d(ji,jj) + (fjln  * zphn * fthk) 
-                      fjln2d(ji,jj) = fjln2d(ji,jj) + (fjlim_pn * zphn * fthk) 
+                      ! fjln2d(ji,jj) = fjln2d(ji,jj) + (fjln(ji,jj)  * zphn(ji,jj) * fse3t(ji,jj,jk)) 
+                      fjln2d(ji,jj) = fjln2d(ji,jj) + (fjlim_pn(ji,jj) * zphn(ji,jj) * fse3t(ji,jj,jk)) 
                   ENDIF
                   IF( med_diag%PN_NLIM%dgsave ) THEN
-                      fnln2d(ji,jj) = fnln2d(ji,jj) + (fnln  * zphn * fthk) 
+                      fnln2d(ji,jj) = fnln2d(ji,jj) + (fnln(ji,jj)  * zphn(ji,jj) * fse3t(ji,jj,jk)) 
                   ENDIF
                   IF( med_diag%PN_FELIM%dgsave ) THEN
-                      ffln2d(ji,jj) = ffln2d(ji,jj) + (ffln  * zphn * fthk) 
+                      ffln2d(ji,jj) = ffln2d(ji,jj) + (ffln(ji,jj)  * zphn(ji,jj) * fse3t(ji,jj,jk)) 
                   ENDIF
                   IF( med_diag%PD_JLIM%dgsave ) THEN
-                      ! fjld2d(ji,jj) = fjld2d(ji,jj) + (fjld  * zphd * fthk) 
-                      fjld2d(ji,jj) = fjld2d(ji,jj) + (fjlim_pd * zphd * fthk) 
+                      ! fjld2d(ji,jj) = fjld2d(ji,jj) + (fjld(ji,jj)  * zphd(ji,jj) * fse3t(ji,jj,jk)) 
+                      fjld2d(ji,jj) = fjld2d(ji,jj) + (fjlim_pd(ji,jj) * zphd(ji,jj) * fse3t(ji,jj,jk)) 
                   ENDIF
                   IF( med_diag%PD_NLIM%dgsave ) THEN
-                      fnld2d(ji,jj) = fnld2d(ji,jj) + (fnld  * zphd * fthk) 
+                      fnld2d(ji,jj) = fnld2d(ji,jj) + (fnld(ji,jj)  * zphd(ji,jj) * fse3t(ji,jj,jk)) 
                   ENDIF
                   IF( med_diag%PD_FELIM%dgsave ) THEN
-                      ffld2d(ji,jj) = ffld2d(ji,jj) + (ffld  * zphd * fthk) 
+                      ffld2d(ji,jj) = ffld2d(ji,jj) + (ffld(ji,jj)  * zphd(ji,jj) * fse3t(ji,jj,jk)) 
                   ENDIF
                   IF( med_diag%PD_SILIM%dgsave ) THEN
-                      fsld2d2(ji,jj) = fsld2d2(ji,jj) + (fsld2 * zphd * fthk) 
+                      fsld2d2(ji,jj) = fsld2d2(ji,jj) + (fsld2(ji,jj) * zphd(ji,jj) * fse3t(ji,jj,jk)) 
                   ENDIF
                   IF( med_diag%PDSILIM2%dgsave ) THEN
-                      fsld2d(ji,jj) = fsld2d(ji,jj) + (fsld  * zphd * fthk)
+                      fsld2d(ji,jj) = fsld2d(ji,jj) + (fsld(ji,jj)  * zphd(ji,jj) * fse3t(ji,jj,jk))
                   ENDIF
                   !! 
                   IF( med_diag%TOTREG_N%dgsave ) THEN
-                      fregen2d(ji,jj) = fregen2d(ji,jj) + fregen
+                      fregen2d(ji,jj) = fregen2d(ji,jj) + fregen(ji,jj)
                   ENDIF
                   IF( med_diag%TOTRG_SI%dgsave ) THEN
-                      fregensi2d(ji,jj) = fregensi2d(ji,jj) + fregensi
+                      fregensi2d(ji,jj) = fregensi2d(ji,jj) + fregensi(ji,jj)
                   ENDIF
                   !! 
                   IF( med_diag%FASTN%dgsave ) THEN
-                      ftempn2d(ji,jj) = ftempn2d(ji,jj) + (ftempn  * fthk)
+                      ftempn2d(ji,jj) = ftempn2d(ji,jj) + (ftempn(ji,jj)  * fse3t(ji,jj,jk))
                   ENDIF
                   IF( med_diag%FASTSI%dgsave ) THEN
-                      ftempsi2d(ji,jj) = ftempsi2d(ji,jj) + (ftempsi * fthk)
+                      ftempsi2d(ji,jj) = ftempsi2d(ji,jj) + (ftempsi(ji,jj) * fse3t(ji,jj,jk))
                   ENDIF
                   IF( med_diag%FASTFE%dgsave ) THEN
-                      ftempfe2d(ji,jj) =ftempfe2d(ji,jj)  + (ftempfe * fthk)  
+                      ftempfe2d(ji,jj) =ftempfe2d(ji,jj)  + (ftempfe(ji,jj) * fse3t(ji,jj,jk))  
                   ENDIF
                   IF( med_diag%FASTC%dgsave ) THEN
-                      ftempc2d(ji,jj) = ftempc2d(ji,jj) + (ftempc  * fthk)
+                      ftempc2d(ji,jj) = ftempc2d(ji,jj) + (ftempc(ji,jj)  * fse3t(ji,jj,jk))
                   ENDIF
                   IF( med_diag%FASTCA%dgsave ) THEN
-                      ftempca2d(ji,jj) = ftempca2d(ji,jj) + (ftempca * fthk)
+                      ftempca2d(ji,jj) = ftempca2d(ji,jj) + (ftempca(ji,jj) * fse3t(ji,jj,jk))
                   ENDIF
                   !! 
                   IF( med_diag%REMINN%dgsave ) THEN
-                      freminn2d(ji,jj) = freminn2d(ji,jj) + (freminn  * fthk)
+                      freminn2d(ji,jj) = freminn2d(ji,jj) + (freminn(ji,jj)  * fse3t(ji,jj,jk))
                   ENDIF
                   IF( med_diag%REMINSI%dgsave ) THEN
-                      freminsi2d(ji,jj) = freminsi2d(ji,jj) + (freminsi * fthk)
+                      freminsi2d(ji,jj) = freminsi2d(ji,jj) + (freminsi(ji,jj) * fse3t(ji,jj,jk))
                   ENDIF
                   IF( med_diag%REMINFE%dgsave ) THEN
-                      freminfe2d(ji,jj)= freminfe2d(ji,jj) + (freminfe * fthk) 
+                      freminfe2d(ji,jj)= freminfe2d(ji,jj) + (freminfe(ji,jj) * fse3t(ji,jj,jk)) 
                   ENDIF
                   IF( med_diag%REMINC%dgsave ) THEN
-                      freminc2d(ji,jj) = freminc2d(ji,jj) + (freminc  * fthk) 
+                      freminc2d(ji,jj) = freminc2d(ji,jj) + (freminc(ji,jj)  * fse3t(ji,jj,jk)) 
                   ENDIF
                   IF( med_diag%REMINCA%dgsave ) THEN
-                      freminca2d(ji,jj) = freminca2d(ji,jj) + (freminca * fthk) 
+                      freminca2d(ji,jj) = freminca2d(ji,jj) + (freminca(ji,jj) * fse3t(ji,jj,jk)) 
                   ENDIF
                   !!
@@ -4200,5 +4174,5 @@
                         ffastca(ji,jj)/MAX(ffastc(ji,jj), rsmall)
                      ENDIF
-                  ELSE IF (jk.eq.jmbathy) THEN
+                  ELSE IF (jk.eq.mbathy(ji,jj)) THEN
                      IF( med_diag%IBEN_N%dgsave ) THEN
                         iben_n2d(ji,jj) = f_sbenin_n(ji,jj)  + f_fbenin_n(ji,jj)
@@ -4244,17 +4218,17 @@
                   !!
                   IF( med_diag%RIV_N%dgsave ) THEN
-                     rivn2d(ji,jj) = rivn2d(ji,jj) +  (f_riv_loc_n * fthk)
+                     rivn2d(ji,jj) = rivn2d(ji,jj) +  (f_riv_loc_n(ji,jj) * fse3t(ji,jj,jk))
                   ENDIF
                   IF( med_diag%RIV_SI%dgsave ) THEN
-                     rivsi2d(ji,jj) = rivsi2d(ji,jj) +  (f_riv_loc_si * fthk)
+                     rivsi2d(ji,jj) = rivsi2d(ji,jj) +  (f_riv_loc_si(ji,jj) * fse3t(ji,jj,jk))
                   ENDIF
                   IF( med_diag%RIV_C%dgsave ) THEN
-                     rivc2d(ji,jj) = rivc2d(ji,jj) +  (f_riv_loc_c * fthk)
+                     rivc2d(ji,jj) = rivc2d(ji,jj) +  (f_riv_loc_c(ji,jj) * fse3t(ji,jj,jk))
                   ENDIF
                   IF( med_diag%RIV_ALK%dgsave ) THEN
-                     rivalk2d(ji,jj) = rivalk2d(ji,jj) +  (f_riv_loc_alk * fthk)
+                     rivalk2d(ji,jj) = rivalk2d(ji,jj) +  (f_riv_loc_alk(ji,jj) * fse3t(ji,jj,jk))
                   ENDIF
                   IF( med_diag%DETC%dgsave ) THEN
-                     fslowc2d(ji,jj) = fslowc2d(ji,jj) + (fslowc  * fthk)   
+                     fslowc2d(ji,jj) = fslowc2d(ji,jj) + (fslowc(ji,jj)  * fse3t(ji,jj,jk))   
                   ENDIF
                   !! 
@@ -4262,74 +4236,74 @@
                   !!
                   IF( med_diag%PN_LLOSS%dgsave ) THEN
-                     fdpn22d(ji,jj) = fdpn22d(ji,jj) + (fdpn2  * fthk)
+                     fdpn22d(ji,jj) = fdpn22d(ji,jj) + (fdpn2(ji,jj)  * fse3t(ji,jj,jk))
                   ENDIF
                   IF( med_diag%PD_LLOSS%dgsave ) THEN
-                     fdpd22d(ji,jj) = fdpd22d(ji,jj) + (fdpd2  * fthk)
+                     fdpd22d(ji,jj) = fdpd22d(ji,jj) + (fdpd2(ji,jj)  * fse3t(ji,jj,jk))
                   ENDIF
                   IF( med_diag%ZI_LLOSS%dgsave ) THEN
-                     fdzmi22d(ji,jj) = fdzmi22d(ji,jj) + (fdzmi2 * fthk)
+                     fdzmi22d(ji,jj) = fdzmi22d(ji,jj) + (fdzmi2(ji,jj) * fse3t(ji,jj,jk))
                   ENDIF
                   IF( med_diag%ZE_LLOSS%dgsave ) THEN
-                     fdzme22d(ji,jj) = fdzme22d(ji,jj) + (fdzme2 * fthk)
+                     fdzme22d(ji,jj) = fdzme22d(ji,jj) + (fdzme2(ji,jj) * fse3t(ji,jj,jk))
                   ENDIF
                   IF( med_diag%ZI_MES_N%dgsave ) THEN
                      zimesn2d(ji,jj) = zimesn2d(ji,jj) +  &
-                     (xphi * (fgmipn + fgmid) * fthk)
+                     (xphi * (fgmipn(ji,jj) + fgmid(ji,jj)) * fse3t(ji,jj,jk))
                   ENDIF
                   IF( med_diag%ZI_MES_D%dgsave ) THEN
                      zimesd2d(ji,jj) = zimesd2d(ji,jj) + & 
-                     ((1. - xbetan) * finmi * fthk)
+                     ((1. - xbetan) * finmi(ji,jj) * fse3t(ji,jj,jk))
                   ENDIF
                   IF( med_diag%ZI_MES_C%dgsave ) THEN
                      zimesc2d(ji,jj) = zimesc2d(ji,jj) + &
-                     (xphi * ((xthetapn * fgmipn) + fgmidc) * fthk)
+                     (xphi * ((xthetapn * fgmipn(ji,jj)) + fgmidc(ji,jj)) * fse3t(ji,jj,jk))
                   ENDIF
                   IF( med_diag%ZI_MESDC%dgsave ) THEN
                      zimesdc2d(ji,jj) = zimesdc2d(ji,jj) + &
-                     ((1. - xbetac) * ficmi * fthk)
+                     ((1. - xbetac) * ficmi(ji,jj) * fse3t(ji,jj,jk))
                   ENDIF
                   IF( med_diag%ZI_EXCR%dgsave ) THEN
-                     ziexcr2d(ji,jj) = ziexcr2d(ji,jj) +  (fmiexcr * fthk)
+                     ziexcr2d(ji,jj) = ziexcr2d(ji,jj) +  (fmiexcr(ji,jj) * fse3t(ji,jj,jk))
                   ENDIF
                   IF( med_diag%ZI_RESP%dgsave ) THEN
-                     ziresp2d(ji,jj) = ziresp2d(ji,jj) +  (fmiresp * fthk)
+                     ziresp2d(ji,jj) = ziresp2d(ji,jj) +  (fmiresp(ji,jj) * fse3t(ji,jj,jk))
                   ENDIF
                   IF( med_diag%ZI_GROW%dgsave ) THEN
-                     zigrow2d(ji,jj) = zigrow2d(ji,jj) + (fmigrow * fthk)
+                     zigrow2d(ji,jj) = zigrow2d(ji,jj) + (fmigrow(ji,jj) * fse3t(ji,jj,jk))
                   ENDIF
                   IF( med_diag%ZE_MES_N%dgsave ) THEN
                      zemesn2d(ji,jj) = zemesn2d(ji,jj) + &
-                     (xphi * (fgmepn + fgmepd + fgmezmi + fgmed) * fthk)
+                     (xphi * (fgmepn(ji,jj) + fgmepd(ji,jj) + fgmezmi(ji,jj) + fgmed(ji,jj)) * fse3t(ji,jj,jk))
                   ENDIF
                   IF( med_diag%ZE_MES_D%dgsave ) THEN
                      zemesd2d(ji,jj) = zemesd2d(ji,jj) + &
-                     ((1. - xbetan) * finme * fthk)
+                     ((1. - xbetan) * finme(ji,jj) * fse3t(ji,jj,jk))
                   ENDIF
                   IF( med_diag%ZE_MES_C%dgsave ) THEN
                      zemesc2d(ji,jj) = zemesc2d(ji,jj) +                         & 
-                     (xphi * ((xthetapn * fgmepn) + (xthetapd * fgmepd) +  &
-                     (xthetazmi * fgmezmi) + fgmedc) * fthk)
+                     (xphi * ((xthetapn * fgmepn(ji,jj)) + (xthetapd * fgmepd(ji,jj)) +  &
+                     (xthetazmi * fgmezmi(ji,jj)) + fgmedc(ji,jj)) * fse3t(ji,jj,jk))
                   ENDIF
                   IF( med_diag%ZE_MESDC%dgsave ) THEN
                      zemesdc2d(ji,jj) = zemesdc2d(ji,jj) +  &
-                     ((1. - xbetac) * ficme * fthk)
+                     ((1. - xbetac) * ficme(ji,jj) * fse3t(ji,jj,jk))
                   ENDIF
                   IF( med_diag%ZE_EXCR%dgsave ) THEN
-                     zeexcr2d(ji,jj) = zeexcr2d(ji,jj) + (fmeexcr * fthk)
+                     zeexcr2d(ji,jj) = zeexcr2d(ji,jj) + (fmeexcr(ji,jj) * fse3t(ji,jj,jk))
                   ENDIF
                   IF( med_diag%ZE_RESP%dgsave ) THEN
-                     zeresp2d(ji,jj) = zeresp2d(ji,jj) + (fmeresp * fthk)
+                     zeresp2d(ji,jj) = zeresp2d(ji,jj) + (fmeresp(ji,jj) * fse3t(ji,jj,jk))
                   ENDIF
                   IF( med_diag%ZE_GROW%dgsave ) THEN
-                     zegrow2d(ji,jj) = zegrow2d(ji,jj) + (fmegrow * fthk)
+                     zegrow2d(ji,jj) = zegrow2d(ji,jj) + (fmegrow(ji,jj) * fse3t(ji,jj,jk))
                   ENDIF
                   IF( med_diag%MDETC%dgsave ) THEN
-                     mdetc2d(ji,jj) = mdetc2d(ji,jj) + (fddc * fthk)
+                     mdetc2d(ji,jj) = mdetc2d(ji,jj) + (fddc(ji,jj) * fse3t(ji,jj,jk))
                   ENDIF
                   IF( med_diag%GMIDC%dgsave ) THEN
-                     gmidc2d(ji,jj) = gmidc2d(ji,jj) + (fgmidc * fthk)
+                     gmidc2d(ji,jj) = gmidc2d(ji,jj) + (fgmidc(ji,jj) * fse3t(ji,jj,jk))
                   ENDIF
                   IF( med_diag%GMEDC%dgsave ) THEN
-                     gmedc2d(ji,jj) = gmedc2d(ji,jj) + (fgmedc  * fthk)
+                     gmedc2d(ji,jj) = gmedc2d(ji,jj) + (fgmedc(ji,jj)  * fse3t(ji,jj,jk))
                   ENDIF
                   !!
@@ -4338,13 +4312,13 @@
                   !! ** 3D diagnostics
                   IF( med_diag%TPP3%dgsave ) THEN
-                     tpp3d(ji,jj,jk) =  (fprn * zphn) + (fprd * zphd)
+                     tpp3d(ji,jj,jk) =  (fprn(ji,jj) * zphn(ji,jj)) + (fprd(ji,jj) * zphd(ji,jj))
                      !CALL iom_put( "TPP3"  , tpp3d )
                   ENDIF
                   IF( med_diag%TPPD3%dgsave ) THEN
-                     tppd3(ji,jj,jk) =  (fprd * zphd)
+                     tppd3(ji,jj,jk) =  (fprd(ji,jj) * zphd(ji,jj))
                   ENDIF
                   
                   IF( med_diag%REMIN3N%dgsave ) THEN
-                     remin3dn(ji,jj,jk) = fregen + (freminn * fthk) !! remineralisation
+                     remin3dn(ji,jj,jk) = fregen(ji,jj) + (freminn(ji,jj) * fse3t(ji,jj,jk)) !! remineralisation
                      !CALL iom_put( "REMIN3N"  , remin3dn )
                   ENDIF
@@ -4358,58 +4332,58 @@
 		  !! AXY (09/11/16): CMIP6 diagnostics
 		  IF ( med_diag%DCALC3%dgsave   ) THEN
-                     dcalc3(ji,jj,jk) = freminca
+                     dcalc3(ji,jj,jk) = freminca(ji,jj)
                   ENDIF
 		  IF ( med_diag%FEDISS3%dgsave  ) THEN
-                     fediss3(ji,jj,jk) = ffetop
+                     fediss3(ji,jj,jk) = ffetop(ji,jj)
                   ENDIF
 		  IF ( med_diag%FESCAV3%dgsave  ) THEN
-                     fescav3(ji,jj,jk) = ffescav
+                     fescav3(ji,jj,jk) = ffescav(ji,jj)
                   ENDIF
 		  IF ( med_diag%MIGRAZP3%dgsave ) THEN
-                     migrazp3(ji,jj,jk) = fgmipn * xthetapn
+                     migrazp3(ji,jj,jk) = fgmipn(ji,jj) * xthetapn
                   ENDIF
 		  IF ( med_diag%MIGRAZD3%dgsave ) THEN
-                     migrazd3(ji,jj,jk) = fgmidc
+                     migrazd3(ji,jj,jk) = fgmidc(ji,jj)
                   ENDIF
 		  IF ( med_diag%MEGRAZP3%dgsave ) THEN
-                     megrazp3(ji,jj,jk) = (fgmepn * xthetapn) + (fgmepd * xthetapd)
+                     megrazp3(ji,jj,jk) = (fgmepn(ji,jj) * xthetapn) + (fgmepd(ji,jj) * xthetapd)
                   ENDIF
 		  IF ( med_diag%MEGRAZD3%dgsave ) THEN
-                     megrazd3(ji,jj,jk) = fgmedc
+                     megrazd3(ji,jj,jk) = fgmedc(ji,jj)
                   ENDIF
 		  IF ( med_diag%MEGRAZZ3%dgsave ) THEN
-                     megrazz3(ji,jj,jk) = (fgmezmi * xthetazmi)
+                     megrazz3(ji,jj,jk) = (fgmezmi(ji,jj) * xthetazmi)
                   ENDIF
 		  IF ( med_diag%PBSI3%dgsave    ) THEN
-                     pbsi3(ji,jj,jk)    = (fprds * zpds)
+                     pbsi3(ji,jj,jk)    = (fprds(ji,jj) * zpds(ji,jj))
                   ENDIF
 		  IF ( med_diag%PCAL3%dgsave    ) THEN
-                     pcal3(ji,jj,jk)    = ftempca
+                     pcal3(ji,jj,jk)    = ftempca(ji,jj)
                   ENDIF
 		  IF ( med_diag%REMOC3%dgsave   ) THEN
-                     remoc3(ji,jj,jk)   = freminc
+                     remoc3(ji,jj,jk)   = freminc(ji,jj)
                   ENDIF
 		  IF ( med_diag%PNLIMJ3%dgsave  ) THEN
-                     ! pnlimj3(ji,jj,jk)  = fjln
-                     pnlimj3(ji,jj,jk)  = fjlim_pn
+                     ! pnlimj3(ji,jj,jk)  = fjln(ji,jj)
+                     pnlimj3(ji,jj,jk)  = fjlim_pn(ji,jj)
                   ENDIF
 		  IF ( med_diag%PNLIMN3%dgsave  ) THEN
-                     pnlimn3(ji,jj,jk)  = fnln
+                     pnlimn3(ji,jj,jk)  = fnln(ji,jj)
                   ENDIF
 		  IF ( med_diag%PNLIMFE3%dgsave ) THEN
-                     pnlimfe3(ji,jj,jk) = ffln
+                     pnlimfe3(ji,jj,jk) = ffln(ji,jj)
                   ENDIF
 		  IF ( med_diag%PDLIMJ3%dgsave  ) THEN
-                     ! pdlimj3(ji,jj,jk)  = fjld
-                     pdlimj3(ji,jj,jk)  = fjlim_pd
+                     ! pdlimj3(ji,jj,jk)  = fjld(ji,jj)
+                     pdlimj3(ji,jj,jk)  = fjlim_pd(ji,jj)
                   ENDIF
 		  IF ( med_diag%PDLIMN3%dgsave  ) THEN
-                     pdlimn3(ji,jj,jk)  = fnld
+                     pdlimn3(ji,jj,jk)  = fnld(ji,jj)
                   ENDIF
 		  IF ( med_diag%PDLIMFE3%dgsave ) THEN
-                     pdlimfe3(ji,jj,jk) = ffld
+                     pdlimfe3(ji,jj,jk) = ffld(ji,jj)
                   ENDIF
 		  IF ( med_diag%PDLIMSI3%dgsave ) THEN
-                     pdlimsi3(ji,jj,jk) = fsld2
+                     pdlimsi3(ji,jj,jk) = fsld2(ji,jj)
                   ENDIF
                   !!
@@ -4430,48 +4404,48 @@
                   trc2d(ji,jj,2)  =  ftot_si(ji,jj)                            !! silicon  inventory
                   trc2d(ji,jj,3)  =  ftot_fe(ji,jj)                            !! iron     inventory
-                  trc2d(ji,jj,4)  = trc2d(ji,jj,4)  + (fprn  * zphn * fthk)    !! non-diatom production
-                  trc2d(ji,jj,5)  = trc2d(ji,jj,5)  + (fdpn         * fthk)    !! non-diatom non-grazing losses
-                  trc2d(ji,jj,6)  = trc2d(ji,jj,6)  + (fprd  * zphd * fthk)    !! diatom production
-                  trc2d(ji,jj,7)  = trc2d(ji,jj,7)  + (fdpd         * fthk)    !! diatom non-grazing losses
+                  trc2d(ji,jj,4)  = trc2d(ji,jj,4)  + (fprn(ji,jj)  * zphn(ji,jj) * fse3t(ji,jj,jk))    !! non-diatom production
+                  trc2d(ji,jj,5)  = trc2d(ji,jj,5)  + (fdpn(ji,jj)         * fse3t(ji,jj,jk))    !! non-diatom non-grazing losses
+                  trc2d(ji,jj,6)  = trc2d(ji,jj,6)  + (fprd(ji,jj)  * zphd(ji,jj) * fse3t(ji,jj,jk))    !! diatom production
+                  trc2d(ji,jj,7)  = trc2d(ji,jj,7)  + (fdpd(ji,jj)         * fse3t(ji,jj,jk))    !! diatom non-grazing losses
                   !! diagnostic field  8 is (ostensibly) supplied by trcsed.F            
-                  trc2d(ji,jj,9)  = trc2d(ji,jj,9)  + (fprds * zpds * fthk)    !! diatom silicon production
-                  trc2d(ji,jj,10) = trc2d(ji,jj,10) + (fsdiss  * fthk)         !! diatom silicon dissolution
-                  trc2d(ji,jj,11) = trc2d(ji,jj,11) + (fgmipn  * fthk)         !! microzoo grazing on non-diatoms
-                  trc2d(ji,jj,12) = trc2d(ji,jj,12) + (fgmid   * fthk)         !! microzoo grazing on detrital nitrogen
-                  trc2d(ji,jj,13) = trc2d(ji,jj,13) + (fdzmi   * fthk)         !! microzoo non-grazing losses
-                  trc2d(ji,jj,14) = trc2d(ji,jj,14) + (fgmepn  * fthk)         !! mesozoo  grazing on non-diatoms
-                  trc2d(ji,jj,15) = trc2d(ji,jj,15) + (fgmepd  * fthk)         !! mesozoo  grazing on diatoms
-                  trc2d(ji,jj,16) = trc2d(ji,jj,16) + (fgmezmi * fthk)         !! mesozoo  grazing on microzoo
-                  trc2d(ji,jj,17) = trc2d(ji,jj,17) + (fgmed   * fthk)         !! mesozoo  grazing on detrital nitrogen
-                  trc2d(ji,jj,18) = trc2d(ji,jj,18) + (fdzme   * fthk)         !! mesozoo  non-grazing losses
+                  trc2d(ji,jj,9)  = trc2d(ji,jj,9)  + (fprds(ji,jj) * zpds(ji,jj) * fse3t(ji,jj,jk))    !! diatom silicon production
+                  trc2d(ji,jj,10) = trc2d(ji,jj,10) + (fsdiss(ji,jj)  * fse3t(ji,jj,jk))         !! diatom silicon dissolution
+                  trc2d(ji,jj,11) = trc2d(ji,jj,11) + (fgmipn(ji,jj)  * fse3t(ji,jj,jk))         !! microzoo grazing on non-diatoms
+                  trc2d(ji,jj,12) = trc2d(ji,jj,12) + (fgmid(ji,jj)   * fse3t(ji,jj,jk))         !! microzoo grazing on detrital nitrogen
+                  trc2d(ji,jj,13) = trc2d(ji,jj,13) + (fdzmi(ji,jj)   * fse3t(ji,jj,jk))         !! microzoo non-grazing losses
+                  trc2d(ji,jj,14) = trc2d(ji,jj,14) + (fgmepn(ji,jj)  * fse3t(ji,jj,jk))         !! mesozoo  grazing on non-diatoms
+                  trc2d(ji,jj,15) = trc2d(ji,jj,15) + (fgmepd(ji,jj)  * fse3t(ji,jj,jk))         !! mesozoo  grazing on diatoms
+                  trc2d(ji,jj,16) = trc2d(ji,jj,16) + (fgmezmi(ji,jj) * fse3t(ji,jj,jk))         !! mesozoo  grazing on microzoo
+                  trc2d(ji,jj,17) = trc2d(ji,jj,17) + (fgmed(ji,jj)   * fse3t(ji,jj,jk))         !! mesozoo  grazing on detrital nitrogen
+                  trc2d(ji,jj,18) = trc2d(ji,jj,18) + (fdzme(ji,jj)   * fse3t(ji,jj,jk))         !! mesozoo  non-grazing losses
                   !! diagnostic field 19 is (ostensibly) supplied by trcexp.F
-                  trc2d(ji,jj,20) = trc2d(ji,jj,20) + (fslown  * fthk)         !! slow sinking detritus N production
-                  trc2d(ji,jj,21) = trc2d(ji,jj,21) + (fdd     * fthk)         !! detrital remineralisation
-                  trc2d(ji,jj,22) = trc2d(ji,jj,22) + (ffetop  * fthk)         !! aeolian  iron addition
-                  trc2d(ji,jj,23) = trc2d(ji,jj,23) + (ffebot  * fthk)         !! seafloor iron addition
-                  trc2d(ji,jj,24) = trc2d(ji,jj,24) + (ffescav * fthk)         !! "free" iron scavenging
-                  trc2d(ji,jj,25) = trc2d(ji,jj,25) + (fjlim_pn * zphn * fthk) !! non-diatom J  limitation term 
-                  trc2d(ji,jj,26) = trc2d(ji,jj,26) + (fnln  * zphn * fthk)    !! non-diatom N  limitation term 
-                  trc2d(ji,jj,27) = trc2d(ji,jj,27) + (ffln  * zphn * fthk)    !! non-diatom Fe limitation term 
-                  trc2d(ji,jj,28) = trc2d(ji,jj,28) + (fjlim_pd * zphd * fthk) !! diatom     J  limitation term 
-                  trc2d(ji,jj,29) = trc2d(ji,jj,29) + (fnld  * zphd * fthk)    !! diatom     N  limitation term 
-                  trc2d(ji,jj,30) = trc2d(ji,jj,30) + (ffld  * zphd * fthk)    !! diatom     Fe limitation term 
-                  trc2d(ji,jj,31) = trc2d(ji,jj,31) + (fsld2 * zphd * fthk)    !! diatom     Si limitation term 
-                  trc2d(ji,jj,32) = trc2d(ji,jj,32) + (fsld  * zphd * fthk)    !! diatom     Si uptake limitation term
+                  trc2d(ji,jj,20) = trc2d(ji,jj,20) + (fslown(ji,jj)  * fse3t(ji,jj,jk))         !! slow sinking detritus N production
+                  trc2d(ji,jj,21) = trc2d(ji,jj,21) + (fdd(ji,jj)     * fse3t(ji,jj,jk))         !! detrital remineralisation
+                  trc2d(ji,jj,22) = trc2d(ji,jj,22) + (ffetop(ji,jj)  * fse3t(ji,jj,jk))         !! aeolian  iron addition
+                  trc2d(ji,jj,23) = trc2d(ji,jj,23) + (ffebot(ji,jj)  * fse3t(ji,jj,jk))         !! seafloor iron addition
+                  trc2d(ji,jj,24) = trc2d(ji,jj,24) + (ffescav(ji,jj) * fse3t(ji,jj,jk))         !! "free" iron scavenging
+                  trc2d(ji,jj,25) = trc2d(ji,jj,25) + (fjlim_pn(ji,jj) * zphn(ji,jj) * fse3t(ji,jj,jk)) !! non-diatom J  limitation term 
+                  trc2d(ji,jj,26) = trc2d(ji,jj,26) + (fnln(ji,jj)  * zphn(ji,jj) * fse3t(ji,jj,jk))    !! non-diatom N  limitation term 
+                  trc2d(ji,jj,27) = trc2d(ji,jj,27) + (ffln(ji,jj)  * zphn(ji,jj) * fse3t(ji,jj,jk))    !! non-diatom Fe limitation term 
+                  trc2d(ji,jj,28) = trc2d(ji,jj,28) + (fjlim_pd(ji,jj) * zphd(ji,jj) * fse3t(ji,jj,jk)) !! diatom     J  limitation term 
+                  trc2d(ji,jj,29) = trc2d(ji,jj,29) + (fnld(ji,jj)  * zphd(ji,jj) * fse3t(ji,jj,jk))    !! diatom     N  limitation term 
+                  trc2d(ji,jj,30) = trc2d(ji,jj,30) + (ffld(ji,jj)  * zphd(ji,jj) * fse3t(ji,jj,jk))    !! diatom     Fe limitation term 
+                  trc2d(ji,jj,31) = trc2d(ji,jj,31) + (fsld2(ji,jj) * zphd(ji,jj) * fse3t(ji,jj,jk))    !! diatom     Si limitation term 
+                  trc2d(ji,jj,32) = trc2d(ji,jj,32) + (fsld(ji,jj)  * zphd(ji,jj) * fse3t(ji,jj,jk))    !! diatom     Si uptake limitation term
                   if (jk.eq.i0100) trc2d(ji,jj,33) = fslownflux(ji,jj)         !! slow detritus flux at  100 m
                   if (jk.eq.i0200) trc2d(ji,jj,34) = fslownflux(ji,jj)         !! slow detritus flux at  200 m
                   if (jk.eq.i0500) trc2d(ji,jj,35) = fslownflux(ji,jj)         !! slow detritus flux at  500 m
                   if (jk.eq.i1000) trc2d(ji,jj,36) = fslownflux(ji,jj)         !! slow detritus flux at 1000 m
-                  trc2d(ji,jj,37) = trc2d(ji,jj,37) + fregen                   !! non-fast N  full column regeneration
-                  trc2d(ji,jj,38) = trc2d(ji,jj,38) + fregensi                 !! non-fast Si full column regeneration
+                  trc2d(ji,jj,37) = trc2d(ji,jj,37) + fregen(ji,jj)                   !! non-fast N  full column regeneration
+                  trc2d(ji,jj,38) = trc2d(ji,jj,38) + fregensi(ji,jj)                 !! non-fast Si full column regeneration
                   if (jk.eq.i0100) trc2d(ji,jj,39) = trc2d(ji,jj,37)           !! non-fast N  regeneration to  100 m
                   if (jk.eq.i0200) trc2d(ji,jj,40) = trc2d(ji,jj,37)           !! non-fast N  regeneration to  200 m
                   if (jk.eq.i0500) trc2d(ji,jj,41) = trc2d(ji,jj,37)           !! non-fast N  regeneration to  500 m
                   if (jk.eq.i1000) trc2d(ji,jj,42) = trc2d(ji,jj,37)           !! non-fast N  regeneration to 1000 m
-                  trc2d(ji,jj,43) = trc2d(ji,jj,43) + (ftempn  * fthk)         !! fast sinking detritus N production
-                  trc2d(ji,jj,44) = trc2d(ji,jj,44) + (ftempsi * fthk)         !! fast sinking detritus Si production
-                  trc2d(ji,jj,45) = trc2d(ji,jj,45) + (ftempfe * fthk)         !! fast sinking detritus Fe production
-                  trc2d(ji,jj,46) = trc2d(ji,jj,46) + (ftempc  * fthk)         !! fast sinking detritus C production
-                  trc2d(ji,jj,47) = trc2d(ji,jj,47) + (ftempca * fthk)         !! fast sinking detritus CaCO3 production
+                  trc2d(ji,jj,43) = trc2d(ji,jj,43) + (ftempn(ji,jj)  * fse3t(ji,jj,jk))         !! fast sinking detritus N production
+                  trc2d(ji,jj,44) = trc2d(ji,jj,44) + (ftempsi(ji,jj) * fse3t(ji,jj,jk))         !! fast sinking detritus Si production
+                  trc2d(ji,jj,45) = trc2d(ji,jj,45) + (ftempfe(ji,jj) * fse3t(ji,jj,jk))         !! fast sinking detritus Fe production
+                  trc2d(ji,jj,46) = trc2d(ji,jj,46) + (ftempc(ji,jj)  * fse3t(ji,jj,jk))         !! fast sinking detritus C production
+                  trc2d(ji,jj,47) = trc2d(ji,jj,47) + (ftempca(ji,jj) * fse3t(ji,jj,jk))         !! fast sinking detritus CaCO3 production
                   if (jk.eq.i0100) trc2d(ji,jj,48) = ffastn(ji,jj)             !! fast detritus N  flux at  100 m
                   if (jk.eq.i0200) trc2d(ji,jj,49) = ffastn(ji,jj)             !! fast detritus N  flux at  200 m
@@ -4490,10 +4464,10 @@
                   if (jk.eq.i0500) trc2d(ji,jj,62) = fregenfastsi(ji,jj)       !! Si regeneration to  500 m
                   if (jk.eq.i1000) trc2d(ji,jj,63) = fregenfastsi(ji,jj)       !! Si regeneration to 1000 m
-                  trc2d(ji,jj,64) = trc2d(ji,jj,64) + (freminn  * fthk)        !! sum of fast-sinking N  fluxes
-                  trc2d(ji,jj,65) = trc2d(ji,jj,65) + (freminsi * fthk)        !! sum of fast-sinking Si fluxes
-                  trc2d(ji,jj,66) = trc2d(ji,jj,66) + (freminfe * fthk)        !! sum of fast-sinking Fe fluxes
-                  trc2d(ji,jj,67) = trc2d(ji,jj,67) + (freminc  * fthk)        !! sum of fast-sinking C  fluxes
-                  trc2d(ji,jj,68) = trc2d(ji,jj,68) + (freminca * fthk)        !! sum of fast-sinking Ca fluxes
-                  if (jk.eq.jmbathy) then
+                  trc2d(ji,jj,64) = trc2d(ji,jj,64) + (freminn(ji,jj)  * fse3t(ji,jj,jk))        !! sum of fast-sinking N  fluxes
+                  trc2d(ji,jj,65) = trc2d(ji,jj,65) + (freminsi(ji,jj) * fse3t(ji,jj,jk))        !! sum of fast-sinking Si fluxes
+                  trc2d(ji,jj,66) = trc2d(ji,jj,66) + (freminfe(ji,jj) * fse3t(ji,jj,jk))        !! sum of fast-sinking Fe fluxes
+                  trc2d(ji,jj,67) = trc2d(ji,jj,67) + (freminc(ji,jj)  * fse3t(ji,jj,jk))        !! sum of fast-sinking C  fluxes
+                  trc2d(ji,jj,68) = trc2d(ji,jj,68) + (freminca(ji,jj) * fse3t(ji,jj,jk))        !! sum of fast-sinking Ca fluxes
+                  if (jk.eq.mbathy(ji,jj)) then
                      trc2d(ji,jj,69) = fsedn(ji,jj)                                   !! N  sedimentation flux                                  
                      trc2d(ji,jj,70) = fsedsi(ji,jj)                                  !! Si sedimentation flux
@@ -4504,5 +4478,5 @@
                   if (jk.eq.1)  trc2d(ji,jj,74) = qsr(ji,jj)
                   if (jk.eq.1)  trc2d(ji,jj,75) = xpar(ji,jj,jk)
-                  !! if (jk.eq.1)  trc2d(ji,jj,75) = real(iters)
+                  !! if (jk.eq.1)  trc2d(ji,jj,75) = real(iters(ji,jj))
                   !! diagnostic fields 76 to 80 calculated below
                   trc2d(ji,jj,81) = trc2d(ji,jj,81) + fprn_ml(ji,jj)           !! mixed layer non-diatom production
